Attribute VB_Name = "TUSBK02AD"
'-----------------------------------------------
'API for TUSB-K02AD Driver
'Visual Basic 6 Module
'
'Aug. 23 2006
'Copyright (C) 2006 Turtle Industry Co.,Ltd.
'-----------------------------------------------

'API Function declaration

Declare Function TUSBK02AD_Ad_Single Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal Ch As Byte, ByRef Dat As Integer) As Integer
Declare Function TUSBK02AD_Ad_Start Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal Ch As Byte, ByVal TrgCh As Byte, ByVal Clk As Long) As Integer
Declare Function TUSBK02AD_Ad_Stop Lib "TUSK02AD.DLL" (ByVal Id As Integer) As Integer
Declare Function TUSBK02AD_DIO_Dir Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal b As Byte, ByVal dir As Byte) As Integer
Declare Function TUSBK02AD_DIO_In Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByRef data As Byte) As Integer
Declare Function TUSBK02AD_DIO_Out Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal b As Byte, ByVal data As Byte) As Integer
Declare Function TUSBK02AD_DIO_Status Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByRef data As Byte) As Integer
Declare Function TUSBK02AD_ExtTimer Lib "TUSK02AD.DLL" (ByVal Clk As Long) As Double
Declare Function TUSBK02AD_ExtTimer_Set Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal Clk As Long) As Integer
Declare Function TUSBK02AD_Get_Data Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByRef dat1 As Integer, ByRef dat2 As Integer, ByRef Leng As Long) As Integer
Declare Function TUSBK02AD_Get_Status Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByRef Status As Byte, Leng As Long) As Integer
Declare Function TUSBK02AD_IntClk Lib "TUSK02AD.DLL" (ByVal Clk As Long) As Double
Declare Function TUSBK02AD_Trigger_Set Lib "TUSK02AD.DLL" (ByVal Id As Integer, ByVal TrgType As Byte, ByVal Level As Integer, ByVal Hys As Integer, ByVal PreLen As Long) As Integer
Declare Function TUSBK02AD_Chk Lib "TUSK02AD.DLL" (ByVal Id As Integer) As Integer
Declare Function TUSBK02AD_SoftTrigger Lib "TUSK02AD.DLL" (ByVal Id As Integer) As Integer
Declare Sub TUSBK02AD_Load Lib "TUSK02AD.DLL" ()
Declare Sub TUSBK02AD_Unload Lib "TUSK02AD.DLL" ()

' Error Message
Public Function TUSBK02AD_ErrorDisp(ByVal ErrCode As Integer)
    Dim str As String
    
    Select Case ErrCode
    Case 0
        str = "ɏI܂"
    Case 2
        str = "hCoĂ܂"
    Case 6
        str = "foCX܂ł"
    Case 8
        str = "p[^G["
    Case 9
        str = "USBʐMG["
    Case 11
        str = "A捞쒆ł"
    Case 13
        str = "JnĂ܂"
    Case 14
        str = "I[o[t["
    Case 15
        str = "f[^уG["
    Case Default
        str = "sȃG[ł"
    End Select
    
    MsgBox (str)
End Function

