Option Strict Off
Option Explicit On
Module TUSBK02AD
	'-----------------------------------------------
	'API for TUSB-K02AD Driver
	'Visual Basic 6 Module
	'
    'Oct. 27 2006
	'Copyright (C) 2006 Turtle Industry Co.,Ltd.
	'-----------------------------------------------
	
	'API Function declaration
	
	Declare Function TUSBK02AD_Ad_Single Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal Ch As Byte, ByRef Dat As Short) As Short
	Declare Function TUSBK02AD_Ad_Start Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal Ch As Byte, ByVal TrgCh As Byte, ByVal Clk As Integer) As Short
	Declare Function TUSBK02AD_Ad_Stop Lib "TUSK02AD.DLL" (ByVal Id As Short) As Short
    Declare Function TUSBK02AD_DIO_Dir Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal b As Byte, ByVal direction As Byte) As Short
    Declare Function TUSBK02AD_DIO_In Lib "TUSK02AD.DLL" (ByVal Id As Short, ByRef data As Byte) As Short
	Declare Function TUSBK02AD_DIO_Out Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal b As Byte, ByVal data As Byte) As Short
	Declare Function TUSBK02AD_DIO_Status Lib "TUSK02AD.DLL" (ByVal Id As Short, ByRef data As Byte) As Short
	Declare Function TUSBK02AD_ExtTimer Lib "TUSK02AD.DLL" (ByVal Clk As Integer) As Double
	Declare Function TUSBK02AD_ExtTimer_Set Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal Clk As Integer) As Short
	Declare Function TUSBK02AD_Get_Data Lib "TUSK02AD.DLL" (ByVal Id As Short, ByRef dat1 As Short, ByRef dat2 As Short, ByRef Leng As Integer) As Short
	Declare Function TUSBK02AD_Get_Status Lib "TUSK02AD.DLL" (ByVal Id As Short, ByRef Status As Byte, ByRef Leng As Integer) As Short
	Declare Function TUSBK02AD_IntClk Lib "TUSK02AD.DLL" (ByVal Clk As Integer) As Double
	Declare Function TUSBK02AD_Trigger_Set Lib "TUSK02AD.DLL" (ByVal Id As Short, ByVal TrgType As Byte, ByVal Level As Short, ByVal Hys As Short, ByVal PreLen As Integer) As Short
	Declare Function TUSBK02AD_Chk Lib "TUSK02AD.DLL" (ByVal Id As Short) As Short
	Declare Function TUSBK02AD_SoftTrigger Lib "TUSK02AD.DLL" (ByVal Id As Short) As Short
	Declare Sub TUSBK02AD_Load Lib "TUSK02AD.DLL" ()
	Declare Sub TUSBK02AD_Unload Lib "TUSK02AD.DLL" ()
	
	' Error Message
	Public Function TUSBK02AD_ErrorDisp(ByVal ErrCode As Short) As Object
        Dim tmpStr As String

        Select Case ErrCode
            Case 0
                tmpStr = "ɏI܂"
            Case 2
                tmpStr = "hCoĂ܂"
            Case 6
                tmpStr = "foCX܂ł"
            Case 8
                tmpStr = "p[^G["
            Case 9
                tmpStr = "USBʐMG["
            Case 11
                tmpStr = "A捞쒆ł"
            Case 13
                tmpStr = "JnĂ܂"
            Case 14
                tmpStr = "I[o[t["
            Case 15
                tmpStr = "f[^уG["
            Case Else
                tmpStr = "sȃG[ł"
        End Select

        MsgBox(tmpStr)
	End Function
End Module