// DevForm.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "K02ADSample.h"
#include "DevForm.h"
#include "TUSK02AD.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER1	1//Ď^C}[
#define TIMER2	2//ADϊL^^C}[

/////////////////////////////////////////////////////////////////////////////
// CDevForm _CAO


CDevForm::CDevForm(CWnd* pParent /*=NULL*/)
	: CDialog(CDevForm::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevForm)
	m_IOSel0 = -1;
	m_IOSel1 = -1;
	m_ExtClock = 0;
	m_AdData1 = _T("");
	m_AdData2 = _T("");
	m_TriggerType = -1;
	m_TriggerCh = -1;
	m_TriggerLevel = 0.0;
	m_HysLevel = 0.0;
	m_PreTriggerLen = 0;
	m_Sel1 = FALSE;
	m_Sel2 = FALSE;
	m_ClockSel = -1;
	m_IntClock = 0;
	m_SamplingStatus = _T("");
	//}}AFX_DATA_INIT
}


void CDevForm::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevForm)
	DDX_Control(pDX, IDC_SAMPLING_STATUS, m_SamplingStatus_Control);
	DDX_Control(pDX, IDC_EXT_CLOCK_DISP, m_ExtClockDisp_Control);
	DDX_Control(pDX, IDC_INT_CLOCK_DISP, m_IntClockDisp_Control);
	DDX_Control(pDX, IDC_PRE_TRIGGER_LEN, m_PreTriggerLen_Control);
	DDX_Control(pDX, IDC_HYS_LEVEL, m_HysLevel_Control);
	DDX_Control(pDX, IDC_TRIGGER_LEVEL, m_TriggerLevel_Control);
	DDX_Control(pDX, IDC_TRIGGER_CH, m_TriggerCh_Control);
	DDX_Control(pDX, IDC_INT_CLOCK, m_IntClock_Control);
	DDX_Control(pDX, IDC_CLOCKSEL1, m_ClockSel_Control1);
	DDX_Control(pDX, IDC_CLOCKSEL2, m_ClockSel_Control2);
	DDX_Control(pDX, IDC_SEL2, m_Sel2_Control);
	DDX_Control(pDX, IDC_SEL1, m_Sel1_Control);
	DDX_Control(pDX, IDC_TRIGGER_TYPE, m_TriggerType_Control);
	DDX_Control(pDX, IDC_D1VIEW, m_D1View);
	DDX_Control(pDX, IDC_D0VIEW, m_D0View);
	DDX_Control(pDX, IDC_SOFT_TRIGGER, m_SoftTrigger_Control);
	DDX_Control(pDX, IDC_REC_STOP, m_RecStop_Control);
	DDX_Control(pDX, IDC_REC_START, m_RecStart_Control);
	DDX_Control(pDX, IDC_SINGLE_SAMPLE, m_SingleSample_Control);
	DDX_Control(pDX, IDC_CLOCK_OUT, m_ClockOut_Control);
	DDX_Control(pDX, IDC_IOSEL1, m_IOSel1_Control);
	DDX_Control(pDX, IDC_IOSEL0, m_IOSel0_Control);
	DDX_CBIndex(pDX, IDC_IOSEL0, m_IOSel0);
	DDX_CBIndex(pDX, IDC_IOSEL1, m_IOSel1);
	DDX_Text(pDX, IDC_EXT_CLOCK, m_ExtClock);
	DDX_Text(pDX, IDC_AD_DATA1, m_AdData1);
	DDX_Text(pDX, IDC_AD_DATA2, m_AdData2);
	DDX_CBIndex(pDX, IDC_TRIGGER_TYPE, m_TriggerType);
	DDX_CBIndex(pDX, IDC_TRIGGER_CH, m_TriggerCh);
	DDX_Text(pDX, IDC_TRIGGER_LEVEL, m_TriggerLevel);
	DDV_MinMaxDouble(pDX, m_TriggerLevel, -2.5, 2.5);
	DDX_Text(pDX, IDC_HYS_LEVEL, m_HysLevel);
	DDV_MinMaxDouble(pDX, m_HysLevel, 0., 50.);
	DDX_Text(pDX, IDC_PRE_TRIGGER_LEN, m_PreTriggerLen);
	DDV_MinMaxLong(pDX, m_PreTriggerLen, 0, 1048576);
	DDX_Check(pDX, IDC_SEL1, m_Sel1);
	DDX_Check(pDX, IDC_SEL2, m_Sel2);
	DDX_Radio(pDX, IDC_CLOCKSEL1, m_ClockSel);
	DDX_Text(pDX, IDC_INT_CLOCK, m_IntClock);
	DDX_Text(pDX, IDC_SAMPLING_STATUS, m_SamplingStatus);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevForm, CDialog)
	//{{AFX_MSG_MAP(CDevForm)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_EXT_CLOCK, OnChangeExtClock)
	ON_EN_CHANGE(IDC_INT_CLOCK, OnChangeIntClock)
	ON_WM_CREATE()
	ON_CBN_SELCHANGE(IDC_IOSEL0, OnSelchangeIosel0)
	ON_CBN_SELCHANGE(IDC_IOSEL1, OnSelchangeIosel1)
	ON_BN_CLICKED(IDC_CLOCK_OUT, OnClockOut)
	ON_BN_CLICKED(IDC_SINGLE_SAMPLE, OnSingleSample)
	ON_BN_CLICKED(IDC_REC_START, OnRecStart)
	ON_CBN_SELCHANGE(IDC_TRIGGER_TYPE, OnSelchangeTriggerType)
	ON_BN_CLICKED(IDC_CLOCKSEL1, OnClocksel1)
	ON_BN_CLICKED(IDC_CLOCKSEL2, OnClocksel2)
	ON_BN_CLICKED(IDC_REC_STOP, OnRecStop)
	ON_BN_CLICKED(IDC_SOFT_TRIGGER, OnSoftTrigger)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevForm bZ[W nh

// This Form module initialize
void CDevForm::SetId(short Id)
{
	short retErr;
	char str[30];

	DevId = Id;

	UpdateData(TRUE);

	sprintf(str,"ID = %d  Panel",DevId);
	SendMessage(WM_SETTEXT,0,(LPARAM)str);
	retErr = TUSBK02AD_DIO_Status(DevId, IOStatus );
	if( retErr != 0 )
	{
		m_EtcFunc.ErrorDisp(NULL,retErr);
		ShowWindow(SW_HIDE);
	}
	else
	{
		m_IOSel0 = IOStatus[0];
		m_IOSel1 = IOStatus[1];
	}

	UpdateData(FALSE);
	m_TriggerCh_Control.EnableWindow(FALSE);
	m_TriggerLevel_Control.EnableWindow(FALSE);
	m_HysLevel_Control.EnableWindow(FALSE);
	m_RecStop_Control.EnableWindow(FALSE);
	OnChangeExtClock();
	OnChangeIntClock();

	SetTimer(TIMER1,100,NULL);
}

// timer handler
void CDevForm::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent )
	{
	case TIMER1:
		if( TUSBK02AD_Chk(DevId) != 0 )
		{
			ShowWindow(SW_HIDE);
			KillTimer(TIMER1);
		}
		else
		{
			DIO_Check();
		}
		break;
	case TIMER2:
		char AdStatus;
		long DataLen;
		short retErr;
		char str[50];
		DWORD stLeng;
		
		retErr = TUSBK02AD_Get_Status(DevId, &AdStatus, &DataLen);

		if( retErr )
		{
			KillTimer(TIMER2);// Timer2 is suspended.
			m_EtcFunc.ErrorDisp(NULL,retErr);
			OnRecStop();
			break;
		}

		if( TUSBK02AD_Get_Data(DevId, m_dat1, m_dat2, &DataLen) )
		{
			KillTimer(TIMER2);// Timer2 is suspended.
			m_EtcFunc.ErrorDisp(NULL,retErr);
			OnRecStop();
			break;
		}

		for( long cnt = 0 ; cnt < DataLen ; cnt++ )
		{
			sprintf(str,"%d,%d\n",m_dat1[cnt],m_dat2[cnt]);
			stLeng = strlen(str);
			WriteFile(h_SAVEFILE,str,stLeng,&stLeng,NULL );
		}

		m_TotalLeng += DataLen;
		sprintf(str,"Status = %d     TotalLen = %d",AdStatus,m_TotalLeng);
		m_SamplingStatus_Control.SetWindowText(str);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CDevForm::DIO_Check()
{
	BYTE data;
	short retErr;

	retErr = TUSBK02AD_DIO_In(DevId, &data);
    
	if( retErr != 0 )
	{
		m_EtcFunc.ErrorDisp(NULL,retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}

	if( data & 0x01 )
		m_D0View.SetWindowText("High");
	else
		m_D0View.SetWindowText("Low");

	if( data & 0x02 )
		m_D1View.SetWindowText("High");
	else
		m_D1View.SetWindowText("Low");
}


// Ext Clock Value Check
void CDevForm::OnChangeExtClock() 
{
	UpdateData(TRUE);
	if( 1000 <= m_ExtClock && m_ExtClock <= 500000000 )
	{
		m_ExtClockDisp_Control.SetWindowText(
					m_EtcFunc.LongToCommaStr((long) TUSBK02AD_ExtTimer(m_ExtClock)));
	}
	else
	{
		m_ExtClockDisp_Control.SetWindowText("");
	}
}

// Check internal clock
void CDevForm::OnChangeIntClock() 
{
	UpdateData(TRUE);
	if( 50000 <= m_IntClock && m_IntClock <= 1000000000 )
	{
		m_IntClockDisp_Control.SetWindowText(
					m_EtcFunc.LongToCommaStr((long) TUSBK02AD_IntClk(m_IntClock)));
	}
	else
	{
		m_IntClockDisp_Control.SetWindowText("");
	}
}

int CDevForm::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_ExtClock = 1000;
	m_IntClock = 100000;
	m_TriggerType = 0;
	m_TriggerCh = 0;
	m_Sel1 = TRUE;
	m_Sel2 = TRUE;
	m_ClockSel = 1;
	
	return 0;
}

// Digital Port Direction Change
void CDevForm::SetDir(char b)
{
	char dir;
	short retErr;

	if( IOStatus[b] != 0 )
		dir = 1;
	else
		dir = 0;
	
	retErr = TUSBK02AD_DIO_Dir(DevId, b, dir);

	if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
}

// Digital Port Output Level
void CDevForm::SetDio(char b)
{
	char data;
	short retErr;

	if( IOStatus[b] == 2 )
		data = 1;
	else
		data = 0;

	retErr = TUSBK02AD_DIO_Out(DevId, b, data);

	if( retErr )
		m_EtcFunc.ErrorDisp(NULL,retErr);
}

//setup of Digital IO 0 state
void CDevForm::OnSelchangeIosel0() 
{
	UpdateData(TRUE);
	switch( m_IOSel0 )
	{
	case 0://INPUT
		IOStatus[0] = m_IOSel0;
		SetDir(0);
		break;
	case 1://LOW
		IOStatus[0] = m_IOSel0;
		SetDio(0);
		SetDir(0);
		break;
	case 2://HIGH
		IOStatus[0] = m_IOSel0;
		SetDio(0);
		SetDir(0);
	}
}

//setup of Digital IO 1 state
void CDevForm::OnSelchangeIosel1() 
{
	short retErr;

	UpdateData(TRUE);
	switch( m_IOSel1 )
	{
	case 0://INPUT
		IOStatus[1] = m_IOSel1;
		SetDir(1);
		break;
	case 1://LOW
		IOStatus[1] = m_IOSel1;
		SetDio(1);
		SetDir(1);
		break;
	case 2://HIGH
		IOStatus[1] = m_IOSel1;
		SetDio(1);
		SetDir(1);
	case 3://CLOCK
		retErr = TUSBK02AD_DIO_Status(DevId, IOStatus);
		if( retErr )
		{
			m_EtcFunc.ErrorDisp(NULL,retErr);
			KillTimer(TIMER1);
			ShowWindow(SW_HIDE);
		}
		else if( IOStatus[1] != 3 )
		{
			m_IOSel1 = IOStatus[1];
		}
	}
	UpdateData(FALSE);
}

// Ext Clock Out Command
void CDevForm::OnClockOut() 
{
	short retErr;

	UpdateData(TRUE);

	if( m_ExtClock < 1000 || m_ExtClock > 500000000 )
	{
		MessageBox("Cycle is outside the range.","ERROR",MB_OK);
	}
	else
	{
		retErr = TUSBK02AD_ExtTimer_Set(DevId,m_ExtClock);
		if( retErr )
			m_EtcFunc.ErrorDisp(NULL,retErr);
		else
		{
			m_IOSel1 = 3;
		}
	}
	UpdateData(FALSE);
}

//single sample command
void CDevForm::OnSingleSample() 
{
	short dataI;
	double dataD;

	UpdateData(TRUE);

	TUSBK02AD_Ad_Single( DevId,0,&dataI );
	dataD = (double) dataI;
	dataD = ( dataD - 2048.0 ) / 2048.0 * 2.5;
	m_AdData1.Format("%04.3f",dataD);

	TUSBK02AD_Ad_Single( DevId,1,&dataI );
	dataD = (double) dataI;
	dataD = ( dataD - 2048.0 ) / 2048.0 * 2.5;
	m_AdData2.Format("%04.3f",dataD);

	UpdateData(FALSE);
}

// start command of data recording
void CDevForm::OnRecStart() 
{
	long Clock;
	char chsel;
	short retErr;
	short Level;// Trigger Level
	short Hys;// Hysterisys Level
	long PreLen;// Pre Trigger Len

	UpdateData(TRUE);

	if( m_ClockSel == 1 )//InternalClock
	{
		Clock = m_IntClock;
		if( Clock < 50000 || Clock > 1000000000)
			MessageBox("Cycle is outside the range.","ERROR",MB_OK);
	}
	else
		Clock = 0;

	// Trigger Level Check
	if( m_TriggerType >= 4 )
	{
		Level = (short) ( ( m_TriggerLevel + 2.5 ) / 5.0 * 4096.0 );
		if( Level < 0 )
			Level = 0;
		if( Level > 4095 )
			Level = 4095;
	}
	else
		Level = 0;

	//Hysterisys Level Check
	if( m_TriggerType >= 4 )
	{
		Hys = (short) ( m_HysLevel / 5000.0 * 4096.0 );
		if( Hys < 0 )
			Hys = 0;
		if( Hys > 41 )
			Hys = 41;
	}
	else
		Hys = 0;

	//Pre Trigger Len. Check
	PreLen = m_PreTriggerLen;
    
	// Acquisition of a save file name
	OPENFILENAME ofn;
	char fn[MAX_PATH];
	int ret;

	fn[0] = '\0';
	ZeroMemory(&ofn,sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.Flags = 0;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "Data File (*.dat)|*.dat";
	ofn.lpstrDefExt = "dat";
	ret = GetSaveFileName(&ofn);
	if( ret )
	{
		h_SAVEFILE = CreateFile(fn,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
								FILE_ATTRIBUTE_NORMAL,NULL);// A file is opened.
		if( m_Sel1 )
		{
			if( m_Sel2 )
				chsel = 2;
			else
				chsel = 0;
		}
		else
			chsel = 1;
    
		retErr = TUSBK02AD_Trigger_Set(DevId, m_TriggerType, Level, Hys, PreLen);
		if( retErr )
		{
			CloseHandle(h_SAVEFILE);
			m_EtcFunc.ErrorDisp(NULL,retErr);
			return;
		}
		
		retErr = TUSBK02AD_Ad_Start(DevId, chsel, m_TriggerCh, Clock);
		if( retErr )
		{
			CloseHandle(h_SAVEFILE);
			m_EtcFunc.ErrorDisp(NULL,retErr);
		}
		else
		{
			m_TotalLeng = 0;
			m_dat1 = new short [2097152];
			m_dat2 = new short [2097152];
			SetTimer(TIMER2,100,NULL);
			EnableDisableCont(1);
		}	
	}


}

// Enable Disable change of controls
void CDevForm::EnableDisableCont(char StartStop)
{
	if( StartStop )//Start ( on data recording )
	{
		m_RecStop_Control.EnableWindow(TRUE);
		m_RecStart_Control.EnableWindow(FALSE);
		m_SingleSample_Control.EnableWindow(FALSE);
		m_TriggerType_Control.EnableWindow(FALSE);
		m_Sel1_Control.EnableWindow(FALSE);
		m_Sel2_Control.EnableWindow(FALSE);
		m_ClockSel_Control1.EnableWindow(FALSE);
		m_ClockSel_Control2.EnableWindow(FALSE);
		m_PreTriggerLen_Control.EnableWindow(FALSE);

		m_IntClock_Control.EnableWindow(FALSE);


		m_TriggerCh_Control.EnableWindow(FALSE);
		m_TriggerLevel_Control.EnableWindow(FALSE);
		m_HysLevel_Control.EnableWindow(FALSE);
	}
	else//Stop
	{
		m_RecStop_Control.EnableWindow(FALSE);
		m_RecStart_Control.EnableWindow(TRUE);
		m_SingleSample_Control.EnableWindow(TRUE);
		m_TriggerType_Control.EnableWindow(TRUE);
		m_Sel1_Control.EnableWindow(TRUE);
		m_Sel2_Control.EnableWindow(TRUE);
		m_ClockSel_Control1.EnableWindow(TRUE);
		m_ClockSel_Control2.EnableWindow(TRUE);
		m_PreTriggerLen_Control.EnableWindow(TRUE);

		if( m_ClockSel == 1 )
			m_IntClock_Control.EnableWindow(TRUE);

		OnSelchangeTriggerType();
	}
}

// Trigger Type select command
void CDevForm::OnSelchangeTriggerType() 
{
	UpdateData(TRUE);
	switch( m_TriggerType )
	{
	case 0:
	case 1:
	case 2:
	case 3:
		m_TriggerCh_Control.EnableWindow(FALSE);
		m_TriggerLevel_Control.EnableWindow(FALSE);
		m_HysLevel_Control.EnableWindow(FALSE);
		break;
	case 4:
	case 5:
		m_TriggerCh_Control.EnableWindow(TRUE);
		m_TriggerLevel_Control.EnableWindow(TRUE);
		m_HysLevel_Control.EnableWindow(TRUE);
		break;
	case 6:
	case 7:
	case 8:
	case 9:
		m_TriggerCh_Control.EnableWindow(TRUE);
		m_TriggerLevel_Control.EnableWindow(TRUE);
		m_HysLevel_Control.EnableWindow(FALSE);
		break;
	}
}

// When SelExtClock is checked
void CDevForm::OnClocksel1() 
{
	m_IntClock_Control.EnableWindow(FALSE);
}

// When SelIntClk is checked
void CDevForm::OnClocksel2() 
{
	m_IntClock_Control.EnableWindow(TRUE);
}

// stop command of data recording
void CDevForm::OnRecStop() 
{
	short retErr;
	char str[50];
	DWORD stLeng;
	long DataLen;

	KillTimer(TIMER2);

	retErr = TUSBK02AD_Ad_Stop(DevId);
    
	if( retErr )
	{
		m_EtcFunc.ErrorDisp(NULL,retErr);
	}
	else
	{
		DataLen = 2097152;
		retErr = TUSBK02AD_Get_Data(DevId, m_dat1, m_dat2, &DataLen);
		if( retErr )
		{
			KillTimer(TIMER2);// Timer1 is suspended.
			m_EtcFunc.ErrorDisp(NULL,retErr);
		}
		else
		{
			for( int cnt = 0 ; cnt < DataLen ; cnt++ )
			{
				sprintf(str,"%d,%d\n",m_dat1[cnt],m_dat2[cnt]);
				stLeng = strlen(str);
				WriteFile(h_SAVEFILE,str,stLeng,&stLeng,NULL );
			}

			m_TotalLeng += DataLen;
			m_SamplingStatus.Format("TotalLen = %d",m_TotalLeng);
			UpdateData(FALSE);
		}
	}

	CloseHandle(h_SAVEFILE);
	delete [] m_dat1;
	delete [] m_dat2;
    EnableDisableCont(0);
}

// soft trigger command
void CDevForm::OnSoftTrigger() 
{
	TUSBK02AD_SoftTrigger(DevId);
}

void CDevForm::OnClose() 
{
	if( m_RecStop_Control.IsWindowEnabled() )
	{
		KillTimer(TIMER2);
		TUSBK02AD_Ad_Stop(DevId);
	}
	KillTimer(TIMER1);

	CDialog::OnClose();
}
